Index: java/main/src/main/java/com/framsticks/diagnostics/DiagnosticsEndpoint.java
===================================================================
--- java/main/src/main/java/com/framsticks/diagnostics/DiagnosticsEndpoint.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/diagnostics/DiagnosticsEndpoint.java	(revision 85)
@@ -1,4 +1,5 @@
 package com.framsticks.diagnostics;
 
+import com.framsticks.core.Instance;
 import com.framsticks.dumping.PrintWriterSink;
 import com.framsticks.dumping.SaveStream;
@@ -8,8 +9,12 @@
 import com.framsticks.util.PeriodicTask;
 import com.framsticks.util.StateFunctor;
+import com.framsticks.util.io.Encoding;
+
 import org.apache.log4j.Logger;
 
 import java.io.File;
+import java.io.FileOutputStream;
 import java.io.IOException;
+import java.io.OutputStreamWriter;
 import java.io.PrintWriter;
 import java.text.SimpleDateFormat;
@@ -22,5 +27,4 @@
 
 	private final static Logger log = Logger.getLogger(DiagnosticsEndpoint.class.getName());
-
 
 	public DiagnosticsEndpoint() {
@@ -39,5 +43,5 @@
 
 		if (getObserver().dumpsInterval != null) {
-			new PeriodicTask(instance, getObserver().dumpsInterval * 1000) {
+			new PeriodicTask<Instance>(instance, getObserver().dumpsInterval * 1000) {
 				@Override
 				public void run() {
@@ -55,5 +59,5 @@
 								final String fileName = getObserver().dumpsPath + "/" + instance + "_" + new SimpleDateFormat(getObserver().dumpsFormat).format(new Date()) + ".param";
 								File file = new File(fileName);
-								new SaveStream(new PrintWriterSink(new PrintWriter(file)), instance, instance.getRootPath(), new StateFunctor() {
+								new SaveStream(new PrintWriterSink(new PrintWriter(new OutputStreamWriter(new FileOutputStream(file), Encoding.getFramsticksCharset()))), instance, instance.getRootPath(), new StateFunctor() {
 									@Override
 									public void call(Exception e) {
Index: java/main/src/main/java/com/framsticks/dumping/FileInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 85)
@@ -5,4 +5,5 @@
 import com.framsticks.core.Instance;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.io.Encoding;
 
 import org.apache.commons.configuration.Configuration;
@@ -11,6 +12,7 @@
 import java.io.BufferedReader;
 import java.io.File;
-import java.io.FileReader;
+import java.io.FileInputStream;
 import java.io.IOException;
+import java.io.InputStreamReader;
 
 /**
@@ -36,6 +38,5 @@
 		super.run();
 		try {
-			FileReader fileReader = new FileReader(file);
-			LoadStream stream = new LoadStream(this.getRootPath(), new BufferedReader(fileReader), this, new Future<Path>() {
+			LoadStream stream = new LoadStream(this.getRootPath(), new BufferedReader(new InputStreamReader(new FileInputStream(file), Encoding.getFramsticksCharset())), this, new Future<Path>() {
 				@Override
 				public void result(Path result, Exception e) {
Index: java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 85)
@@ -13,4 +13,5 @@
 import com.framsticks.util.dispatching.Dispatching;
 import org.apache.log4j.Logger;
+import com.framsticks.util.dispatching.RunAt;
 
 import java.util.HashSet;
@@ -43,5 +44,5 @@
 	protected void dispatchWrite(final Path path) {
 		++dispatched;
-		instance.invokeLater(new Runnable() {
+		instance.invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
Index: java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java
===================================================================
--- java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 85)
@@ -43,8 +43,8 @@
 
 		registry.putInfoIntoCache(new FramsClass("ModelBuilderRoot", "ModelBuilderRoot", null)
-				.append(new ParamBuilder().setType("o Model").setId("model").setName("model").build())
-				.append(new ParamBuilder().setType("s 1").setId("genotype").setName("genotype").build())
+				.append(Param.build().type("o Model").id("model").name("model"))
+				.append(Param.build().type("s 1").id("genotype").name("genotype"))
 		);
-		root = new Node((CompositeParam)new ParamBuilder().setType("o ModelBuilderRoot").setId(name).setName("Instance").build(), PropertiesAccess.createPropertiesMap());
+		root = new Node((CompositeParam)Param.build().type("o ModelBuilderRoot").id(name).name("Instance").finish(), PropertiesAccess.createPropertiesMap());
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 85)
@@ -19,9 +19,10 @@
 import java.util.List;
 import java.util.Set;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
  * @author Piotr Sniegowski
  */
-public class Browser extends Observer implements Dispatcher {
+public class Browser extends Observer {
 
 	private static final Logger log = Logger.getLogger(Browser.class.getName());
@@ -78,5 +79,5 @@
 	public void autoResolvePath(final String path, final Future<Path> future) {
 		final Instance i = endpoints.get("localhost").getInstance();
-		i.invokeLater(new Runnable() {
+		i.invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -89,5 +90,5 @@
 						}
 						if (e == null) {
-							mainFrame.invokeLater(new Runnable() {
+							mainFrame.invokeLater(new RunAt<Frame>() {
 								@Override
 								public void run() {
@@ -142,9 +143,9 @@
 
 		for (final Endpoint e : getEndpoints().values()) {
-			e.invokeLater(new Runnable() {
+			e.invokeLater(new RunAt<Instance>() {
 				@Override
 				public void run() {
 					final Path p = e.getInstance().getRootPath();
-					invokeLater(new Runnable() {
+					invokeLater(new RunAt<Browser>() {
 						@Override
 						public void run() {
@@ -199,6 +200,6 @@
 
 	@Override
-	public Dispatcher createDefaultDispatcher() {
-		return SwingDispatcher.instance;
+	public Dispatcher<Entity> createDefaultDispatcher() {
+		return SwingDispatcher.getInstance();
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java	(revision 85)
@@ -14,4 +14,5 @@
 
 import javax.swing.tree.TreePath;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
@@ -121,4 +122,8 @@
 				}
 				Path p = new Path(path.getInstance(), nodes, n);
+
+				//TODO breaks immutable
+				path.setInstance(path.getInstance());
+
 				log.debug("forced resolution: creating treenode for " + p);
 				TreeNode childNode = new TreeNode(EndpointAtFrame.this, p);
@@ -146,5 +151,5 @@
 		log.trace("fetched " + path);
 
-		frame.invokeLater(new Runnable() {
+		frame.invokeLater(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -155,5 +160,5 @@
 				final TreeNode result = (TreeNode) treePath.getLastPathComponent();
 				// log.trace("found " + result + " == " + path);
-				instance.invokeLater(new Runnable() {
+				instance.invokeLater(new RunAt<Instance>() {
 					@Override
 					public void run() {
Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 85)
@@ -6,4 +6,5 @@
 import com.framsticks.gui.view.TreeCellRenderer;
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.lang.ScopeEnd;
 import com.framsticks.util.swing.KeyboardModifier;
 import org.apache.log4j.Logger;
@@ -21,4 +22,5 @@
 import java.util.HashMap;
 import java.util.Map;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
@@ -26,5 +28,5 @@
  */
 @SuppressWarnings("serial")
-public class Frame extends JFrame implements Dispatcher {
+public class Frame extends JFrame implements Dispatcher<Frame> {
 
 	private static final Logger log = Logger.getLogger(Frame.class.getName());
@@ -267,6 +269,6 @@
 
 	@Override
-	public void invokeLater(Runnable runnable) {
-		SwingDispatcher.instance.invokeLater(runnable);
+	public void invokeLater(RunAt<? extends Frame> runnable) {
+		SwingDispatcher.getInstance().invokeLater(runnable);
 	}
 
@@ -325,10 +327,10 @@
 	}
 
-	public Runnable startChange(final DefaultMutableTreeNode node) {
+	public ScopeEnd startChange(final DefaultMutableTreeNode node) {
 		assert isActive();
 		final TreePath selection = tree.getSelectionPath();
-		return new Runnable() {
-			@Override
-			public void run() {
+		return new ScopeEnd() {
+			@Override
+			public void close() {
 				assert isActive();
 				treeModel.nodeChanged(node);
@@ -373,13 +375,15 @@
 		final TreePath treePath = endpointsByInstance.get(path.getInstance()).getTreePath(path, false);
 		log.info("go to path: " + path + "(" + treePath + ")");
-		invokeLater(new Runnable() {
+
+		new RunAt<Frame>(this) {
 			@Override
 			public void run() {
+				log.info("executed");
 				tree.setSelectionPath(treePath);
 				tree.makeVisible(treePath);
 				assert tree.isVisible(treePath);
 			}
-
-		});
+		};
+
 	}
 
@@ -387,7 +391,8 @@
 	public void addNode(TreeNode child, DefaultMutableTreeNode parent) {
 		assert isActive();
-		Runnable r = startChange(parent);
-		treeModel.insertNodeInto(child, parent, parent.getChildCount());
-		r.run();
+
+		try (ScopeEnd e = startChange(parent)) {
+			treeModel.insertNodeInto(child, parent, parent.getChildCount());
+		}
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 85)
@@ -15,4 +15,5 @@
 import java.util.Map;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
+import com.framsticks.util.dispatching.RunAt;
 
 @SuppressWarnings("serial")
@@ -73,5 +74,5 @@
 		}
 
-		frame.invokeLater(new Runnable() {
+		frame.invokeLater(new RunAt<Frame>() {
 			@Override
 			public void run() {
Index: java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 85)
@@ -5,14 +5,21 @@
 
 import javax.swing.*;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
  * @author Piotr Sniegowski
  */
-public class SwingDispatcher implements Dispatcher {
+public class SwingDispatcher<C> implements Dispatcher<C> {
 
-	public static final SwingDispatcher instance = new SwingDispatcher();
+	@SuppressWarnings("rawtypes")
+	protected static final SwingDispatcher instance = new SwingDispatcher();
+
+	@SuppressWarnings("unchecked")
+	public static <C> Dispatcher<C> getInstance() {
+		return (Dispatcher<C>) instance;
+	}
 
 	public SwingDispatcher() {
-		invokeLater(new Runnable() {
+		invokeLater(new RunAt<C>() {
 			@Override
 			public void run() {
@@ -28,5 +35,5 @@
 
 	@Override
-	public final void invokeLater(Runnable runnable) {
+	public final void invokeLater(RunAt<? extends C> runnable) {
 		assert !(runnable instanceof Task);
 		SwingUtilities.invokeLater(runnable);
Index: java/main/src/main/java/com/framsticks/gui/TreeNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 85)
@@ -1,6 +1,8 @@
 package com.framsticks.gui;
 
+import com.framsticks.communication.Connection;
 import com.framsticks.communication.Subscription;
 import com.framsticks.communication.util.LoggingStateCallback;
+import com.framsticks.core.Instance;
 import com.framsticks.core.ListChange;
 import com.framsticks.core.Path;
@@ -18,4 +20,5 @@
 import com.framsticks.util.StateFunctor;
 import org.apache.log4j.Logger;
+import com.framsticks.util.dispatching.RunAt;
 
 import javax.swing.tree.DefaultMutableTreeNode;
@@ -40,5 +43,5 @@
 	final protected EndpointAtFrame endpoint;
 
-	final protected Map<EventParam, Subscription> userSubscriptions = new HashMap<EventParam, Subscription>();
+	final protected Map<EventParam, Subscription<?>> userSubscriptions = new HashMap<>();
 	protected Map<ValueControl, Object> localChanges = null;
 	protected String tooltip;
@@ -59,5 +62,5 @@
 		iconName = TreeCellRenderer.findIconName(name, path.getTextual());
 		tooltip = "?";
-		path.getInstance().invokeLater(new Runnable() {
+		path.getInstance().invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -82,5 +85,5 @@
 		assert p.getInstance().isActive();
 		if (Logging.log(log, "fetch", TreeNode.this, e)) {
-			frame.invokeLater(new Runnable() {
+			frame.invokeLater(new RunAt<Frame>() {
 				@Override
 				public void run() {
@@ -92,5 +95,5 @@
 		}
 		updateChildren(p);
-		frame.invokeLater(new Runnable() {
+		frame.invokeLater(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -104,5 +107,5 @@
 		assert !frame.isActive();
 		/** TODO those two actions could be merged into single closure */
-		frame.invokeLater(new Runnable() {
+		frame.invokeLater(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -149,5 +152,5 @@
 		/**If some child were found, update in frame context.*/
 		if (childrenPaths.size() > 0) {
-			frame.invokeLater(new Runnable() {
+			frame.invokeLater(new RunAt<Frame>() {
 				@Override
 				public void run() {
@@ -186,5 +189,5 @@
 		final Path p = path;
 
-		p.getInstance().invokeLater(new Runnable() {
+		p.getInstance().invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -246,5 +249,5 @@
 		final String name = (nameParam != null ? access.get(nameParam, String.class) : path.getTop().getParam().getId());
 
-		frame.invokeLater(new Runnable() {
+		frame.invokeLater(new RunAt<Frame>() {
 			@Override
 			public void run() {
@@ -303,5 +306,5 @@
 		assert p.isResolved();
 		panel.setCurrentTreeNode(this);
-		p.getInstance().invokeLater(new Runnable() {
+		p.getInstance().invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -309,5 +312,5 @@
 				panel.pullValuesFromLocalToUser(access);
 
-				frame.invokeLater(new Runnable() {
+				frame.invokeLater(new RunAt<Frame>() {
 					@Override
 					public void run() {
@@ -341,5 +344,5 @@
 		final Path p = path;
 		log.debug("preparing panel: " + p);
-		p.getInstance().invokeLater(new Runnable() {
+		p.getInstance().invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -347,5 +350,5 @@
 				final CompositeParam param = p.getTop().getParam();
 				final FramsClass framsClass = p.getInstance().getInfoFromCache(param.getContainedTypeName());
-				frame.invokeLater(new Runnable() {
+				frame.invokeLater(new RunAt<Frame>() {
 					@Override
 					public void run() {
@@ -410,5 +413,5 @@
 			return;
 		}
-		userSubscriptions.get(eventParam).unsubscribe(new LoggingStateCallback(log, "unsubscribed " + eventParam));
+		userSubscriptions.get(eventParam).unsubscribe(new LoggingStateCallback<Connection>(log, "unsubscribed " + eventParam));
 		userSubscriptions.remove(eventParam);
 	}
@@ -500,5 +503,5 @@
 		final Map<ValueControl, Object> changes = localChanges;
 		localChanges = null;
-		endpoint.getEndpoint().invokeLater(new Runnable() {
+		endpoint.getEndpoint().invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -514,5 +517,5 @@
 							}
 							log.debug("applied changes for: " + p);
-							frame.invokeLater(new Runnable() {
+							frame.invokeLater(new RunAt<Frame>() {
 								@Override
 								public void run() {
@@ -526,4 +529,3 @@
 		});
 	}
-
 }
Index: java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 85)
@@ -14,5 +14,5 @@
 public class EnumControl extends ValueControl {
 
-	protected final JComboBox list;
+	protected final JComboBox<String> list;
 
 	private static final Logger log = Logger.getLogger(EnumControl.class.getName());
@@ -23,5 +23,5 @@
 		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT));
 
-		list = new JComboBox();
+		list = new JComboBox<String>();
 		for (String item : enumParam.getElements()) {
 			list.addItem(item);
Index: java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java	(revision 85)
@@ -43,5 +43,5 @@
 		logText.setWrapStyleWord(true);
 		logText.setLineWrap(true);
-		JComboBox levelBox = new JComboBox();
+		JComboBox<String> levelBox = new JComboBox<String>();
 		for (String i : STR_) {
 			levelBox.addItem(i);
@@ -49,5 +49,5 @@
 		levelBox.addActionListener(new ActionListener() {
 			public void actionPerformed(ActionEvent e) {
-				levelReporting = ((JComboBox) e.getSource()).getSelectedIndex();
+				levelReporting = ((JComboBox<?>) e.getSource()).getSelectedIndex();
 			}
 		});
Index: java/main/src/main/java/com/framsticks/gui/windows/console/ConsoleFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/windows/console/ConsoleFrame.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/windows/console/ConsoleFrame.java	(revision 85)
@@ -172,5 +172,5 @@
 		addSentMessage(commandText);
 		commandLine.setText("");
-		connection.send(request, new ResponseCallback() {
+		connection.send(request, new ResponseCallback<Connection>() {
 			@Override
 			public void process(Response response) {
Index: java/main/src/main/java/com/framsticks/hosting/InstanceClient.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/InstanceClient.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/hosting/InstanceClient.java	(revision 85)
@@ -5,4 +5,5 @@
 import com.framsticks.communication.queries.GetRequest;
 import com.framsticks.communication.queries.InfoRequest;
+import com.framsticks.core.Instance;
 import com.framsticks.core.Path;
 import com.framsticks.params.*;
@@ -15,4 +16,5 @@
 import java.util.LinkedList;
 import java.util.List;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
@@ -37,6 +39,6 @@
 
 	@Override
-	public void handle(final ApplicationRequest request, final ResponseCallback responseCallback) {
-		instance.invokeLater(new Runnable() {
+	public void handle(final ApplicationRequest request, final ResponseCallback<?> responseCallback) {
+		instance.invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
Index: java/main/src/main/java/com/framsticks/hosting/ServerInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 85)
@@ -4,5 +4,5 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.Param;
 import com.framsticks.core.LocalInstance;
 import com.framsticks.util.dispatching.Future;
@@ -42,5 +42,5 @@
 		hosted.setName("hosted");
 		hosted.configure(hostedConfig);
-		root = new Node((CompositeParam)new ParamBuilder().setName("root").setId("root").setType("o" + hosted.getClass().getCanonicalName()).build(), hosted);
+		root = new Node((CompositeParam)Param.build().name("root").id("root").type("o" + hosted.getClass().getCanonicalName()).finish(), hosted);
 	}
 
